.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include EditEx.inc

      FUNC MACRO parameters:VARARG
        invoke parameters
        EXITM <eax>
      ENDM
      m2m        MACRO M1, M2
        mov eax,M2
        mov M1,eax
      ENDM
      RGB        MACRO red, green, blue
        xor eax, eax
        mov al, blue    ; blue
        rol eax, 8
        mov al, green   ; green
        rol eax, 8
        mov al, red     ; red
      ENDM
      CADD       MACRO quoted_text  
        LOCAL vname,lbl
          jmp lbl
            vname db quoted_text,0
          lbl:
        EXITM <ADDR vname>
      ENDM 
      LOWORD     MACRO bigword
        mov  eax,bigword
        and  eax,0FFFFh     ;; Set to low word
      ENDM
      HIWORD     MACRO bigword
        mov eax,bigword
        shr eax,16
      ENDM



NCSIZE   STRUCT
	line_num_len DWORD ?
	margin_len   DWORD ?
	nc_y         DWORD ?
NCSIZE ENDS


.data
	edit dd 0
	editO dd 0
	hmem dd 0
	show_ln dd 1
	hDlg dd 0
	myFont dd 0
	x_ch dd 0
	y_ch dd 1
	lines dd 10
	SyPos dw 0
	line_l dd 0
	ncsize NCSIZE <0,10,10>
	margin RECT <0,0,0,0>
	line_r RECT <0,0,0,0>
	line_num byte 512 dup (0)
.code

start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax

    invoke InitCommonControls
	invoke DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
	invoke ExitProcess,0

;########################################################################

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		m2m    hDlg, hWin
		invoke GetDlgItem, hWin, 1001
		mov    edit, eax
		invoke SetWindowLong, eax, GWL_WNDPROC, ADDR edit_proc
		mov    editO, eax
		
	.elseif eax==WM_COMMAND

	.elseif eax==WM_SIZE
		mov    eax,lParam
		mov    edx,eax
		shr    eax,16
		and    edx,0ffffh
		;------		
		invoke MoveWindow,edit,0,0,edx,eax,TRUE

	.elseif eax==WM_ERASEBKGND
		mov    eax, TRUE
		ret
	.elseif eax==WM_CLOSE
		invoke EndDialog,hWin,0
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

DlgProc endp

edit_proc proc hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	LOCAL dc:DWORD
	LOCAL hold:DWORD
	LOCAL hbit:DWORD
	LOCAL count:DWORD
	LOCAL tm:TEXTMETRIC
	LOCAL client_x:DWORD
	LOCAL client_y:DWORD
	LOCAL buf[32]:BYTE
	LOCAL ps:PAINTSTRUCT
	LOCAL s_iY:SCROLLINFO
	LOCAL s_iY0:SCROLLINFO
	LOCAL pos:DWORD
	
	.if uMsg == WM_NCPAINT
		mov    dc,FUNC(GetWindowDC,hWnd)
		.if show_ln
			m2m    line_r.right, ncsize.line_num_len
			invoke SelectObject, hmem,myFont
			invoke SetBkMode,    hmem,TRANSPARENT
			invoke SetTextColor, hmem,0;grads.TC
			invoke DrawText,     hmem,ADDR line_num,-1,ADDR line_r,DT_RIGHT
			m2m    margin.bottom,ncsize.nc_y
			m2m    margin.left,ncsize.line_num_len
			m2m    margin.right,ncsize.margin_len
			add    margin.bottom,17
			invoke SetBkMode,  hmem,OPAQUE
			invoke SetBkColor, hmem,0ffffffh
			invoke ExtTextOut, hmem,0,0,ETO_OPAQUE,ADDR margin,0,0,0
			mov    ebx, ncsize.line_num_len
			mov    count,1
@@:		
			invoke SetPixelV,hmem,ebx,count,0
			add    count,2
			mov    eax,ncsize.nc_y
			cmp    count,eax
			jl     @B
			mov    ebx,ncsize.line_num_len
			add    ebx,4  
			invoke BitBlt,dc,0,0,ncsize.margin_len,ncsize.nc_y,hmem,0,0,SRCCOPY
		.endif
		invoke ReleaseDC,hWnd,dc
	.elseif uMsg == WM_NCCALCSIZE
		mov    ebx,lParam
		mov    ecx,eax
		assume ebx:ptr RECT
		mov    eax,ncsize.margin_len
		add    [ebx].left,eax
		invoke MemCopy,ebx,lParam,sizeof RECT
		assume ebx:NOTHING
		.if hmem != NULL
			invoke DeleteDC, hmem
		.endif
		mov    dc,  FUNC(GetWindowDC,hWnd)
		mov    hmem,FUNC(CreateCompatibleDC,dc)
		mov    hbit,FUNC(CreateCompatibleBitmap,dc,ncsize.margin_len,ncsize.nc_y)
		invoke SelectObject, hmem,eax	
		invoke DeleteObject, eax
		invoke DeleteObject, hbit
		invoke ReleaseDC, hWnd, dc
	.elseif uMsg==WM_CHAR || uMsg==WM_VSCROLL || uMsg==WM_KEYDOWN
		mov    s_iY0.cbSize,   sizeof SCROLLINFO
		mov    s_iY0.fMask,    SIF_POS
		invoke GetScrollInfo,  hWnd,  SB_VERT, ADDR s_iY0
		invoke CallWindowProc, editO, hWnd, uMsg, wParam, lParam
		mov    s_iY.cbSize,    sizeof SCROLLINFO
		mov    s_iY.fMask,     SIF_POS
		invoke GetScrollInfo,  hWnd, SB_VERT, ADDR s_iY
		mov    eax, s_iY.nPos
		mov    SyPos, ax
		.if show_ln && eax != s_iY0.nPos
			invoke Initiate_Lines, SyPos
			invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_FRAMECHANGED+SWP_NOSIZE+SWP_NOMOVE+SWP_NOZORDER+SWP_NOACTIVATE
			invoke RGB_proc,0ffffffh, 0444444h
		.endif
		ret
	.elseif uMsg==WM_SIZE
		;invoke CallWindowProc, editO, hWnd, uMsg, wParam, lParam
			
		;mov    s_iY.cbSize,  sizeof SCROLLINFO
		;mov    s_iY.fMask,   SIF_ALL
		;invoke GetScrollInfo,hWnd,SB_VERT,ADDR s_iY
		;mov    eax, s_iY.nMax
		;mov    SyPos, ax

		mov    myFont, FUNC(SendMessage, hWnd, WM_GETFONT, 0, 0)
		mov    dc,FUNC(GetDC,hWnd)
		mov    hold,FUNC(SelectObject,dc, myFont)
		invoke GetTextMetrics,dc,ADDR tm
		invoke SelectObject,dc,hold
		invoke ReleaseDC,hWnd,dc
		mov    eax,  tm.tmAveCharWidth
		mov    x_ch, eax				;width of char
		mov    eax,  tm.tmHeight
		mov    y_ch, eax				;height of char
		HIWORD lParam
		mov    ncsize.nc_y, eax
		add    ncsize.nc_y, 17 ;SCROLLBAR+BORDER=16+1
		xor    edx, edx
		div    y_ch
		mov    lines, eax  ;number of lines
		m2m    line_r.bottom, ncsize.nc_y
		.if show_ln
			invoke Initiate_Lines, SyPos;s_iY.nPos
			invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_FRAMECHANGED+SWP_NOSIZE+SWP_NOMOVE+SWP_NOZORDER+SWP_NOACTIVATE
			invoke RGB_proc,0ffffffh, 0444444h	
		.endif
		;ret
	.endif
	
	invoke CallWindowProc, editO, hWnd, uMsg, wParam, lParam
	ret
edit_proc endp

RGB_proc PROC F_S:DWORD,F_E:DWORD
        LOCAL S_R:DWORD,S_G:DWORD,S_B:DWORD
        LOCAL E_R:DWORD,E_G:DWORD,E_B:DWORD
        LOCAL gal:RECT,br:DWORD
        LOCAL R:BYTE,G:BYTE,B:BYTE,XXX:DWORD

       ;--------------------------
		mov    eax,F_S
		and    eax,000000FFh
		mov    S_R,eax
		mov    eax,F_S
		shr    eax,8
		and    eax,000000FFh
		mov    S_G,eax
		mov    eax,F_S
		shr    eax,16
		and    eax,000000FFh
		mov    S_B,eax
		mov    eax,F_E
		and    eax,000000FFh
		sub    eax,S_R
		mov    E_R,eax
		mov    eax,F_E
		shr    eax,8
		and    eax,000000FFh
		sub    eax,S_G
		mov    E_G,eax
		mov    eax,F_E
		shr    eax,16
		and    eax,000000FFh
		sub    eax,S_B
		mov    E_B,eax
		mov    gal.left,0
		mov    eax,ncsize.line_num_len
		mov    gal.right,eax
		mov    XXX,0
here:
		invoke MulDiv,XXX,ncsize.nc_y,255
		mov    gal.top,eax
		mov    eax,XXX
		inc    eax
		invoke MulDiv,eax,ncsize.nc_y,255
		mov    gal.bottom,eax
		invoke MulDiv,XXX,E_R,255
		add    eax,S_R
		mov    R,al
		invoke MulDiv,XXX,E_G,255
		add    eax,S_G
		mov    G,al
		invoke MulDiv,XXX,E_B,255
		add    eax,S_B
		mov    B,al
		RGB R,G,B
		invoke SetBkColor,   hmem,eax
		invoke ExtTextOut,   hmem,0,0,ETO_OPAQUE,ADDR gal,0,0,0
		inc    XXX
		.IF    XXX < 255
			jmp here
		.ELSEIF XXX==255
			ret
		.ENDIF
		ret
RGB_proc ENDP

Initiate_Lines proc val_min:DWORD
	LOCAL tem[16]:BYTE
	LOCAL num:DWORD
		
		invoke lstrcpy,ADDR line_num,CADD(0)
		mov    eax,val_min
		add    eax,lines
		mov    ebx,eax
		invoke dwtoa,ebx,ADDR tem
		invoke lstrlen,ADDR tem
		mov    num,eax
		mul    x_ch
		.if show_ln
			inc    eax
			mov    ncsize.line_num_len,eax
			add    eax,16
			mov    ncsize.margin_len,eax
		.endif
		mov    ecx,-2
		mov    ebx,val_min
@@:	
		inc    ebx
		push   ebx
		push   ecx
		cmp    ecx,lines
		je     @F
		invoke dwtoa,ebx,ADDR tem
		invoke szCatStr,ADDR line_num,ADDR tem
		invoke szCatStr,ADDR line_num,CADD(13)
		pop    ecx
		pop    ebx
		inc    ecx
		
		jmp    @B
@@:		
		xor    eax,eax		
		ret
Initiate_Lines endp

end start
